if(!com) var com={};
if(!com.clipta) com.clipta={};

com.clipta.toolbar={
	prefs:Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService)
					.getBranch("extensions.cliptatoolbar."),

	search:function(searchurl){
		var searchTermsBox = document.getElementById("cliptaTB-SearchTerms");
		var searchTerms = this.trimString(searchTermsBox.value);
		this.addToHistory(searchTerms)

		searchTerms = this.convertTermsToURI(searchTerms);
		var URL =searchurl+"?q="+searchTerms 
		this.loadURL(URL);
	},
	trimString:function(string){
		if (!string)
			return "";
		string = string.replace(/^\s+/, ''); 
		string = string.replace(/\s+$/, ''); 
		string = string.replace(/\s+/g, ' ');
		return string; 
	},
	addToHistory:function(value){
		var fhService = Components.classes["@mozilla.org/satchel/form-history;1"].
					 getService(Components.interfaces.nsIFormHistory2);
		fhService.addEntry("searchbar-history", value);
	},
	convertTermsToURI:function(terms){	    
		var termArray = new Array();     
		termArray = terms.split(" ");
		var result = "";
		for(var i=0; i<termArray.length; i++){
			if(i > 0)
				result += "+";
			result += encodeURIComponent(termArray[i]);
		} 
		return result; 
	},
	loadURL:function(url){
		window._content.document.location = url;
		window.content.focus();
	},
	extensionManagerWin:null,
	update:function(){
		try {
			if (navigator.userAgent.indexOf('Firefox') != -1 || navigator.userAgent.indexOf('BonEcho') != -1 || navigator.userAgent.indexOf('Minefield') != -1){
				var id = clipta_toolbar_tool.guid;
				var itemType = Components.interfaces.nsIUpdateItem.TYPE_EXTENSION;
				var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
						.getService(Components.interfaces.nsIExtensionManager);
				var items;
				try {
					items = gExtensionManager.getItemList(id, itemType, { });
					var updates = Components.classes["@mozilla.org/updates/update-service;1"]
							.getService(Components.interfaces.nsIUpdateService);

					updates.checkForUpdates(items, items.length, itemType, Components.interfaces.nsIUpdateService.SOURCE_EVENT_USER, window);
				}catch(e){
					BrowserOpenExtensions('extensions');
					items = [gExtensionManager.getItemForID(id)];
					gExtensionManager.update(items, items.length, false, null);
				}
			}
		} catch(e) {
			try {
				const EMTYPE = "Extension:Manager";
				var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
						.getService(Components.interfaces.nsIWindowMediator);
				var theEM = wm.getMostRecentWindow(EMTYPE);
				if (theEM) {
					theEM.focus();
					return;
				}
				const EMURL = "chrome://mozapps/content/extensions/extensions.xul";
				const EMFEATURES = "chrome,menubar,extra-chrome,toolbar,dialog=no,resizable";
				this.extensionManagerWin = 0;
				this.extensionManagerWin  = window.openDialog(EMURL, "", EMFEATURES);

				setTimeout('com.clipta.toolbar.postupdate();', 250);
				return;
			} catch(e) {
			}
		}
	},
	postupdate:function(){
		try{
			if (this.extensionManagerWin  == 0) {
				setTimeout('com.clipta.toolbar.postupdate();', 250);
				return;
			}
			var item = this.extensionManagerWin.document.getElementById('checkUpdatesAllButton');
			item.doCommand();
		} catch(e) { }
	},
	openWall:function(){
		window.openDialog("chrome://cliptatoolbar/content/wall.xul","cliptawall", 
			"dialog=no,chrome,width=900,height=290",this,window);  
	},
	log:function(msg){
		var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
		 getService(Components.interfaces.nsIConsoleService);
		aConsoleService.logStringMessage(msg);
	}
};

com.clipta.languageSwitcher={
	prefs:Components.classes["@mozilla.org/preferences-service;1"].
              getService(Components.interfaces.nsIPrefBranch),
	changeLocale:function(locale){
		this.prefs.setBoolPref("browser.preferences.instantApply",true);	
		this.prefs.setCharPref("general.useragent.locale",locale);
		this.askRestart()
	},
	askRestart:function(){
		var oPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var sTitle = "You need to restart the browser"
		var sMsg = "You need to restart the browser to see the toolbar in the selected language";
		var bRestart = oPromptService.confirm(window,sTitle, sMsg);
		if(bRestart) this.loadAboutConfigAndRestart()
	},
	loadAboutConfigAndRestart:function(){
		window.open("chrome://cliptatoolbar/content/localereload.xul", "localereload", "centerscreen,chrome,close,titlebar,modal",this.restartFirefox); 
		setTimeout('com.clipta.languageSwitcher.restartFirefox();', 500);
	},

	restartFirefox:function(){			
			if (typeof canQuitApplication == "function" && canQuitApplication()){
				var oAppStartup = Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(Components.interfaces.nsIAppStartup);
				if (!oAppStartup.eRestart) throw("You need to restart the browser manually");
				var oRPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.sessionstore.");
				oRPref.setBoolPref("resume_session_once", true);
				oAppStartup.quit(oAppStartup.eAttemptQuit | oAppStartup.eRestart);
			}
	},

	resetLocale:function(){
		var defaultLocale=false
		var defLocaleBranch=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getDefaultBranch("general.useragent.");
		try{
			defaultLocale=defLocaleBranch.getCharPref("locale");
		}catch(e){
				//LOG(e)
		}	
		if(defaultLocale){
			com.clipta.toolbar.prefs.setCharPref("general.useragent.locale",defaultLocale);
			this.askRestart()
		}
	}
}
